/***************************************************************************
 *
 * Copyright 2015-2019 BES.
 * All rights reserved. All unpublished rights reserved.
 *
 * No part of this work may be used or reproduced in any form or by any
 * means, or stored in a database or retrieval system, without prior written
 * permission of BES.
 *
 * Use of this work is governed by a license granted by BES.
 * This work contains confidential and proprietary information of
 * BES. which is protected by copyright, trade secret,
 * trademark and other intellectual property rights.
 *
 ****************************************************************************/
#ifndef __HAL_HWFFT__
#define __HAL_HWFFT__

#ifdef __cplusplus
extern "C" {
#endif

//#include "cmsis_os.h"

#define HWFFT_USE_BUSY_WAIT 1
#define HAVE_EQUIVALENT_MODE 1 /* 128in 128out not 128in 130out mode  */

struct hwfft_t {
    int mode;
    int order;
    int sym_fft;
    //osSemaphoreId _osSemaphoreId;
   // osSemaphoreDef_t _osSemaphoreDef;
//#ifdef CMSIS_OS_RTX
//    uint32_t _semaphore_data[2];
//#endif
};

enum hwfft_mode_t {
    HWFFT_MODE_FFT = 0x1,
    HWFFT_MODE_IFFT = 0x2,
    HWFFT_MODE_EQVL_FFT = 0x4,
    HWFFT_MODE_EQVL_IFFT = 0x8,
};

enum hwfft_order_t {
    HWFFT_ORDER_64SAMP  = 64,
    HWFFT_ORDER_128SAMP = 128,
    HWFFT_ORDER_256SAMP = 256,
    HWFFT_ORDER_512SAMP = 512,
};

bool hwfft_is_enable(void);
int hwfft_destroy(struct hwfft_t *fft_inst);
/*
hwfft_t ṹ
mode: hwfft_mode_tHWFFT_MODE_FFT:   nnʱsym_fftΪ0
                                                                  ʵnʵn/2+1 ʱsym_fftΪ1
                                      HWFFT_MODE_IFFT:   nnʱsym_fftΪ0
                                                                   ʵ n/2+1nʵʱsym_fftΪ1
                                      HWFFT_MODE_EQVL_FFT: spx_fftfftģʽ
                                      HWFFT_MODE_EQVL_IFFT: spx_ifftifftģʽ
                                                                 
order: hwfft_order_t֧ͣ 512/256/128/64  fft/ifft

sym_fft:  1: fftĶԳ;fftnʵn/2+1 
                ifft  n/2+1nʵn Ϊfft/ifft
              0: nn
*/
int hwfft_create(struct hwfft_t *fft_inst, int mode, int order, int sym_fft);
/*
fft/ifft
fft_inst: hwfft_createɵĶӦṹ
in: buf
out: buf
*/
int hwfft_fft_process(struct hwfft_t *fft_inst, short *in, short *out);
/*
 fft/ifft
fft_inst: hwfft_createɵĶӦṹ
in: buffftbuf
out: buf
num: 
mode: 0 һֱȵfftɺŷ
         1 dmaɣfftʼɷأcpuӲfft ʱ
*/
int hwfft_multifft_process(struct hwfft_t *fft_inst, short *in, short *out, unsigned short num,unsigned char mode);

#ifdef __cplusplus
}
#endif

#endif
